#lang plai

(require "streams.rkt")

;; Predicado para definir arreglos con elementos de cualquier tipo.
;; any?: any? -> boolean
(define (any? a) #t)

;; TDA para construir arreglos.
;; Se tienen dos constructores, uno para definir entradas vacías en el arreglo y otro para construir
;; arreglos con un tipo, dimensión y los elementos que son un stream (lista infinita o perezosa).
(define-type Arreglo
   [nulo]
   [arreglo (tipo any?) (dim integer?) (elementos Stream?)])

;; Función que crea un arreglo vacío con un tipo y dimensión.
;; Regresa un arreglo cuyas entradas son (nulo).
;; crea: procedure integer -> Arreglo
(define (crea tipo dim)
   (error 'crea "Función no implementada"))

;; Función que agrega un elemento en el índice indicado.
;; La función verifica que el tipo a agregar sea del tipo correspondiente y que el índice no esté 
;; fuera de rango.
;; Esta función no incrementa el stream asociado sino que reemplaza el valor actual del arreglo en
;; la posición indicada por el nuevo elemento.
;; agrega: Arreglo integer any -> Arreglo
(define (agrega arr ind elm)
   (error 'agrega "Función no implementada"))

;; Función que obtiene el elemento del arreglo en la posición ind.
;; La función verifica que el tipo a agregar sea del tipo correspondiente y que el índice no esté
;; fuera de rango.
;; obten: Arreglo integer -> any
(define (obten arr ind)
   (error 'obten "Función no implementada"))

;; Función que imprime un arreglo en la consola.
;; Se imprimen con formato: [e1|e2|e3|...|en]. Si un elemento es nulo, deja la entrada vacía.
;; imprime: Arreglo -> void
(define (imprime arr)
   (error 'imprime "Función no implementada")
